/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {

    parseClientKey: 'Y0r73BdeT5Wn1dxH9L4iLmdYuptSefQkj9tPRlKt',

    parseAppId: 'Yxik94dF1baLh87x7D5dTWsOhqV5RmnDwcweILhI',

    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
    },

    parseSubscribed: function(){
        //window.location = 'https://www.digitalcade.com';
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var pushNotification;

        try
        {
            pushNotification = window.plugins.pushNotification;
            if (device.platform == 'android' || device.platform == 'Android' ||
                device.platform == 'amazon-fireos' ) {
                pushNotification.register(successHandler, errorHandler, {"senderID":"479830612170","ecb":"onNotification"});		// required!
            } else {
                pushNotification.register(tokenHandler, errorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"onNotificationAPN"});	// required!
            }
        }
        catch(err)
        {
            txt="There was an error on this page.\n\n";
            txt+="Error description: " + err.message + "\n\n";
        }

        // handle APNS notifications for iOS
        function onNotificationAPN(e) {
            if (e.alert) {
                // showing an alert also requires the org.apache.cordova.dialogs plugin
                //navigator.notification.alert(e.alert);
            }

            if (e.sound) {
                // playing a sound also requires the org.apache.cordova.media plugin
                //var snd = new Media(e.sound);
                //snd.play();
            }

            if (e.badge) {
                //pushNotification.setApplicationIconBadgeNumber(successHandler, e.badge);
            }
        }



        function tokenHandler (result) {
            // Your iOS push server needs to know the token before it can push to this device
            // here is where you might want to send it the token for later use.
            window.location = 'https://www.digitalcade.com/digitalcade/home/index?device-id='+result+'&game=word-up&device-platform='+device.platform;
        }

        function successHandler (result) {
        }

        function errorHandler (error) {
        }



    }};

app.initialize();

// handle GCM notifications for Android
function onNotification(e) {

    switch( e.event )
    {
        case 'registered':
            if ( e.regid.length > 0 )
            {
                // Your GCM push server needs to know the regID before it can push to this device
                // here is where you might want to send it the regID for later use.
                window.location = 'https://www.digitalcade.com/digitalcade/home/index?device-id='+e.regid+'&game=word-up&device-platform='+device.platform;
            }
            break;

        case 'message':
            // if this flag is set, this notification happened while we were in the foreground.
            // you might want to play a sound to get the user's attention, throw up a dialog, etc.
            if (e.foreground)
            {

                // on Android soundname is outside the payload.
                // On Amazon FireOS all custom attributes are contained within payload
                //var soundfile = e.soundname || e.payload.sound;
                // if the notification contains a soundname, play it.
                // playing a sound also requires the org.apache.cordova.media plugin
                //var my_media = new Media("/android_asset/www/"+ soundfile);

            }
            else
            {	// otherwise we were launched because the user touched a notification in the notification tray.
            }

            break;

        case 'error':
            break;

        default:
            break;
    }
}

// handle APNS notifications for iOS
function onNotificationAPN(e) {
    if (e.alert) {
        // showing an alert also requires the org.apache.cordova.dialogs plugin
        //navigator.notification.alert(e.alert);
    }

    if (e.sound) {
        // playing a sound also requires the org.apache.cordova.media plugin
    }

    if (e.badge) {
    }
}